function f=benchmark_func(x,func_num)
global M
[ps,D]=size(x);
if D==1
    x=x';
end
    if func_num==1 
        fhde=str2func('sphere_func'); 
    elseif func_num==2 
        fhde=str2func('rosenbrock_func'); 
    elseif func_num==3 fhde=str2func('schwefel_221');    
    elseif func_num==4 fhde=str2func('schwefel_222');
    elseif func_num==5 fhde=str2func('StepFunction'); 
    elseif func_num==6 fhde=str2func('NoisyQuartic'); 
    elseif func_num==7 fhde=str2func('Rastrigin'); 
    elseif func_num==8 fhde=str2func('Noncontinues_Rastrigin'); 
    elseif func_num==9 fhde=str2func('Ackley');
    elseif func_num==10 fhde=str2func('Griewank'); 
    elseif func_num==11 fhde=str2func('penalized_1'); 
    elseif func_num==12 fhde=str2func('penalized_2');            
    elseif func_num==13 fhde=str2func('Rotated_Sphere'); 
    elseif func_num==14 fhde=str2func('Rotated_Rochenbrock');    
    elseif func_num==15 fhde=str2func('Rotated_Schwefel_221');
    elseif func_num==16 fhde=str2func('Rotated_Rastrigin');
    elseif func_num==17 fhde=str2func('Rotated_Ackley');
    elseif func_num==18 fhde=str2func('Rotated_Griewank'); 
        
    elseif func_num==19 fhde=str2func('kowalik'); 
    elseif func_num==20 fhde=str2func('sixhump_camelback');
    elseif func_num==21 fhde=str2func('branin'); 
    elseif func_num==22 fhde=str2func('hartmans_family_1'); 
    elseif func_num==23 fhde=str2func('hartmans_family_2'); 
    elseif func_num==24 fhde=str2func('shekels_family');
    end 
f=feval(fhde,x);
end




%********************************************************* add by Guohua Wu
function fit=sphere_func(x)
[ps,D]=size(x);
fit=sum(x.^2,2);
end

function f=rosenbrock_func(x)
[ps,D]=size(x);
f=sum(100.*(x(:,1:D-1).^2-x(:,2:D)).^2+(x(:,1:D-1)-1).^2,2);
end

function f=schwefel_222(x)
[ps,D]=size(x);
sum2=abs(x(:,1));
for i=2:D
    sum2=sum2.*abs(x(:,i));
end
f=sum(abs(x),2)+sum2;
end


function f = NoisyQuartic(x)
% shift sphere
 [ps,D]=size(x);
 f = x.^4 * [1:D]' + rand(ps,1);
end

function f = StepFunction(x)
% shift sphere
f = sum(floor(x+0.5).^2,2);
end

function f = shift_sphere(x)
% shift sphere
[ps,D]=size(x);
fbias = 0;
f = sum(x.^2);
f = f + fbias;
end

function f = Shifted_Schwefel_222(x)
% Shifted Schwefel 2.22
[ps,D]=size(x);
fbias = 0;
sum2=abs(x(1,1));
for i=2:D
    sum2=sum2.*abs(x(1,i));
end
f=sum(abs(x))+sum2;
f = f + fbias;
end

function f=schwefel_221(x)
f=max(abs(x),[],2);
end

function f = Shifted_Rochenbrock(x)
% Shifted Rochenbrock
[ps,D]=size(x);
fbias = 0;
f=sum(100.*(x(1,1:D-1).^2-x(1,2:D)).^2+(x(1,1:D-1)-1).^2,2);
f = f + fbias;
end

function f = Ackley(x)
% Shifted Ackley
[ps,D]=size(x);
fbias = 0;
f=sum(x.^2,2);
f=20-20.*exp(-0.2.*sqrt(f./D))-exp(sum(cos(2.*pi.*x),2)./D)+exp(1);
f = f + fbias;
end

function f = Griewank(x)
% Shifted Griewank
[ps,D]=size(x);
fbias = 0;
f=1;
for i=1:D
    f=f*cos(x(i)/sqrt(i));
end
f=sum(x.^2)/4000-f+1;
f = f + fbias;
end

function f = Rastrigin(x)
% Shifted Rastrigin
[ps,D]=size(x);
fbias = 0;
f=sum(x.^2-10.*cos(2.*pi.*x)+10,2);
f = f + fbias;
end


function f = Noncontinues_Rastrigin(x)
% Noncontinues Rastrigin
[ps,D]=size(x);
fbias = 0;
x=(abs(x)<0.5).*x+(abs(x)>=0.5).*(round(x.*2)./2);
f=sum(x.^2-10.*cos(2.*pi.*x)+10,2);
f = f + fbias;
end

function f = Rotated_Sphere(x)
% Rotated Sphere
[ps,D]=size(x);
global M
fbias = 0;
M1 = [[0.0634,0.0567,-0.027,0.5037,-0.1723,0.1864,0.0073,-0.331,0.0427,0.0702,0.0033,-0.1497,0.1037,-0.266,-0.0958,0.0316,0.2379,0.5919,0.3364,0.2339,-0.5839,0.3541,0.153,-0.0303,-0.254,0.3157,-0.3515,-0.3048,-0.0602,0.1478;-0.153,0.1836,-0.1434,-0.0304,-0.2405,-0.0345,0.0708,-0.3382,0.574,-0.3,-0.0118,-0.2028,0.1215,0.2763,-0.363,-0.4366,0.2545,0.0187,-0.088,-0.1261,0.1435,0.1647,-0.0062,-0.8468,-0.2766,-0.0723,-0.0401,0.0044,0.0192,-0.4171;-0.0946,-0.1686,-0.1382,0.334,-0.0458,-0.1513,0.1047,0.2763,0.3135,-0.0142,-0.2115,0.2479,0.0617,-0.1012,0.6765,-0.2376,0.2242,-0.1048,0.305,0.4018,-0.032,-0.0858,-0.2679,-0.1195,-0.0407,-0.405,0.015,0.1367,0.289,-0.2633;0.0797,-0.2903,-0.1571,0.1481,-0.314,0.1483,-0.0964,0.3911,-0.004,0.1017,-0.1701,-0.1593,0.1884,0.2973,-0.2498,0.3578,-0.1655,0.1099,-0.0996,0.5365,0.6679,0.1607,0.0302,-0.0084,-0.186,0.172,0.5065,-0.0182,-0.5131,0.0914;-0.391,-0.4052,-0.2928,-0.0334,0.1677,-0.2175,-0.0283,0.6093,-0.1291,0.0154,0.2668,0.0713,-0.0883,0.2002,0.214,-0.2896,-0.2252,-0.0121,-0.4319,-0.1021,0.176,0.8896,0.2969,-0.2323,0.2672,-0.0187,-0.3941,0.071,-0.5007,-0.07;0.1164,-0.1241,0.0017,-0.1166,-0.2871,0.3832,-0.0232,-0.2324,0.3942,0.1802,0.1154,-0.2814,-0.4764,-0.3277,-0.1524,-0.476,-0.2608,-0.3429,0.4188,0.1359,0.5001,0.2248,0.7585,0.142,0.2312,0.1882,0.2215,-0.5378,0.1615,0.3265;0.2808,-0.2046,0.5017,-0.0998,0.3713,-0.2847,0.5037,-0.0311,0.1392,0.6209,0.366,-0.1891,0.0313,-0.2699,0.0818,-0.3026,0.308,0.0578,-0.026,-0.084,0.0049,-0.1337,-0.225,0.2672,-0.3145,0.1311,0.0636,-0.1361,-0.6162,-0.5223;0.2181,-0.0157,-0.0314,-0.2983,-0.6348,-0.0804,-0.0576,0.1963,0.1817,0.1181,-0.0189,0.3376,-0.3502,-0.428,-0.2196,-0.1762,-0.1422,0.2216,0.0615,0.2011,-0.0871,-0.2959,-0.2506,-0.0251,0.1893,0.0504,-0.1499,0.4605,-0.1994,0.3048;-0.0498,0.0941,0.2365,-0.0331,0.1487,0.1668,-0.725,0.1934,0.1608,0.4743,-0.4571,0.4222,-0.4218,-0.2385,-0.0837,0.0406,0.2162,-0.1377,-0.5627,0.1286,-0.2314,-0.1006,0.2975,-0.0167,0.0518,0.2825,0.0297,-0.189,0.0574,-0.3345;-0.1393,0.2221,-0.1201,-0.3161,0.0512,0.2754,-0.3593,-0.443,0.1501,0.302,-0.4705,0.2727,0.4229,0.0241,0.5458,-0.2455,0.046,0.0535,-0.1943,-0.0388,0.253,0.154,-0.268,-0.0313,-0.2632,0.1871,-0.2473,0.203,-0.2886,0.6311;0.2207,-0.1127,-0.0722,-0.0359,0.1016,0.208,0.2199,-0.6066,-0.2139,-0.0627,0.046,0.0928,-0.1125,0.6482,0.1853,-0.6908,0.1702,-0.1758,-0.1474,0.0219,-0.5167,0.0811,-0.1861,0.0354,0.0525,0.5255,0.4733,0.0288,-0.0506,-0.0724;0.1523,0.3589,0.4031,-0.6708,0.0845,-0.1188,0.1671,-0.0959,0.1734,-0.1772,-0.0589,0.1117,-0.0619,0.564,0.4179,0.0746,0.1466,0.3246,0.0755,0.5198,0.2303,-0.3316,0.5117,0.2855,0.2007,-0.1473,-0.4626,-0.0603,-0.499,-0.0197;0.3144,0.0916,0.2413,0.3082,-0.0158,-0.1084,-0.3337,-0.0977,-0.2342,0.199,0.1187,-0.7064,-0.2967,-0.0389,0.4072,0.1088,-0.0931,-0.2537,0.1777,-0.0119,0.014,-0.0801,0.1641,-0.4028,0.1856,-0.416,0.1253,0.4275,-0.0868,0.1357;0.6246,-0.0212,0.1579,0.02,0.0135,-0.1914,0.0531,0.1648,-0.0256,-0.5205,0.2737,0.3727,0.5056,-0.5061,0.1762,-0.1609,0.0912,-0.3194,0.1008,0.172,0.1117,0.1528,-0.0728,-0.3045,0.343,0.3376,-0.0326,-0.3946,-0.1317,-0.2319;-0.3347,0.208,-0.0645,0.4183,0.0642,0.1753,-0.1108,-0.4374,-0.3935,-0.286,0.5691,0.1018,-0.4549,0.0636,-0.1066,0.0198,0.0777,-0.0295,-0.1244,0.2578,0.576,-0.2258,-0.4057,0.1576,-0.0113,0.1485,-0.0555,-0.3551,-0.224,-0.1254;-0.1985,0.4533,-0.104,0.0326,0.0913,-0.569,-0.2729,0.4099,-0.0827,0.1901,-0.0919,-0.0882,-0.2557,0.2568,0.1249,-0.2379,0.2429,0.2646,0.2247,-0.0263,0.0065,0.2445,-0.2119,0.0023,0.3212,0.2758,0.277,-0.5189,0.1805,0.2359;-0.3194,-0.1816,-0.0621,-0.231,-0.1636,0.0627,-0.4456,0.1778,0.3625,-0.1798,0.5556,-0.4202,0.3934,-0.0039,0.4677,0.1122,-0.2192,0.31,0.0126,0.0667,-0.1537,-0.7071,-0.219,0.142,0.2199,0.1742,0.2031,-0.3337,0.0407,-0.3338;0.0529,-0.3061,0.4045,0.1704,-0.0363,-0.1734,0.1608,0.2399,0.7539,-0.2758,-0.292,0.0455,-0.2602,0.293,0.2111,0.1236,-0.189,-0.2211,-0.1775,-0.1485,-0.0812,0.1496,-0.4782,0.206,0.1998,0.0457,-0.1844,-0.1962,-0.0271,0.2167;-0.121,0.1005,0.2047,-0.4727,-0.3383,-0.2948,0.0007,-0.0731,-0.4137,-0.3126,-0.2672,-0.3758,-0.0445,-0.2055,-0.0388,0.1931,-0.2694,-0.3634,0.1165,0.5595,-0.1386,0.4816,-0.5654,0.0681,-0.3043,0.0262,-0.4209,0.0208,0.3257,-0.1533;-0.4493,0.2447,0.1674,-0.1343,-0.2745,0.0395,-0.0064,-0.1051,-0.3108,-0.6935,-0.5264,0.0073,-0.0912,-0.4356,0.1255,-0.2502,-0.1316,0.2137,-0.3316,-0.4853,0.1737,-0.1018,0.2616,0.1676,0.0754,0.0127,0.5482,0.4163,-0.3082,-0.279;0.0556,0.3762,0.1717,0.3889,-0.5057,-0.1594,-0.0567,-0.278,-0.1244,0.4403,-0.0725,0.3321,0.5397,0.564,-0.3762,-0.1796,-0.2121,-0.0666,0.2303,-0.1002,0.0118,0.1817,-0.1839,0.5152,0.3387,-0.3369,-0.1593,0.1454,-0.1364,-0.395;-0.45,0.2384,-0.3702,0.1521,-0.0527,-0.3783,-0.3215,0.0891,0.2221,-0.1731,0.2656,-0.0533,0.2019,-0.1445,-0.3418,0.3055,0.5902,-0.681,0.1668,0.1866,-0.2286,-0.0813,0.4315,0.3948,-0.0617,0.2846,-0.1679,0.2737,-0.3657,-0.1485;-0.5093,0.0551,0.5574,0.1912,-0.5549,0.1726,0.222,0.3923,-0.2627,0.3153,0.0468,0.3175,0.1559,0.0849,0.1815,-0.008,-0.3377,-0.3527,0.1522,-0.3804,-0.0768,-0.2415,0.1064,-0.299,-0.5469,0.2121,-0.0363,-0.2715,-0.0147,0.1938;0.1115,0.6437,0.1166,0.3677,0.299,-0.0605,-0.0122,0.365,0.061,-0.1767,-0.2188,-0.089,0.1069,-0.1514,-0.3639,-0.5315,-0.6229,-0.1554,-0.3021,0.4387,-0.3377,-0.2878,-0.1208,0.2296,-0.2528,0.1305,-0.0085,-0.1097,-0.0759,0.2726;-0.2716,-0.3487,0.0198,0.0602,-0.0167,0.098,0.319,-0.0365,-0.3544,-0.1563,-0.6094,-0.4293,0.1029,0.0561,-0.2172,-0.2336,0.4703,0.1572,-0.0334,0.2842,0.1147,-0.2226,-0.1058,-0.0387,0.839,0.2203,-0.3735,-0.3205,0.3091,0.1012;-0.2848,-0.3868,0.2895,-0.1028,0.5798,0.619,-0.3523,0.2165,-0.2116,-0.2331,-0.02,0.1102,-0.1272,0.1002,-0.2801,-0.108,0.259,-0.0386,0.3754,-0.0238,-0.1776,0.1103,-0.3209,0.2815,0.0747,-0.2609,0.2653,-0.0996,-0.5574,0.1796;-0.4782,0.4535,0.0214,-0.2726,0.1309,0.3229,0.3891,-0.0263,0.2669,0.1357,0.04,0.0586,0.1618,-0.1563,0.1675,0.3833,-0.4748,-0.0471,0.1214,0.249,0.0436,0.1977,-0.1038,-0.375,0.4276,0.6124,0.1973,0.2323,-0.0788,-0.3383;0.1473,0.6225,0.127,-0.0553,-0.4618,0.6691,0.1878,0.6053,0.1994,0.0676,0.1908,-0.0887,0.1075,-0.0388,-0.0477,-0.1971,0.5972,0.0263,-0.4166,-0.021,0.1345,0.43,-0.0709,0.3147,0.2689,-0.1686,0.2133,-0.0269,0.3164,0.0222;0.359,-0.0721,-0.1565,-0.0243,0.3498,0.5227,-0.3677,0.3839,-0.011,-0.1039,-0.1776,-0.1382,-0.0928,-0.1825,0.0703,-0.0572,0.0626,0.1562,0.4774,-0.3839,0.0161,0.0506,-0.0988,0.1442,-0.1716,0.6623,-0.425,0.5839,0.0905,-0.4033;-0.0684,-0.2598,0.6168,0.2563,0.2366,0.0309,-0.2393,0.0987,0.2818,-0.1492,0.4573,0.0322,0.3832,0.289,-0.1717,-0.0916,0.039,0.4638,0.0137,0.0927,0.3184,0.2551,0.0045,0.0185,-0.187,0.1746,0.2572,0.5741,0.5359,0.2261;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end

x = x*M2;
f = sum(x.^2);
f = f + fbias;
end

function f = Rotated_Schwefel_221(x)
% Rotated Schwefel 2.21

global M
[ps,D]=size(x);
fbias = 0;
M1 = [[-0.0196,0.3069,-0.139,0.0233,0.1644,-0.1202,0.1849,-0.2882,-0.1735,0.0279,0.0149,0.1334,0.0129,0.1532,0.2544,0.3743,-0.0221,-0.1054,0.1828,-0.0025,0.0334,-0.1686,-0.2243,-0.1457,0.0199,0.1116,0.1739,-0.0556,0.4217,0.2816;0.1939,0.2103,-0.0582,0.2685,-0.0884,0.1261,0.3435,-0.1173,0.2316,-0.1708,0.0372,0.2069,0.0024,-0.0446,0.2317,-0.3044,-0.0261,0.2046,-0.1037,0.104,-0.1261,0.3089,-0.0391,-0.1307,0.1657,-0.3051,0.0581,0.2883,0.0312,0.0995;0.0854,0.288,-0.1274,-0.0792,-0.2168,-0.1039,0.1178,0.2275,-0.0862,-0.1717,-0.0377,0.1056,-0.2707,0.209,-0.2801,0.2857,-0.2997,0.4368,-0.0075,0.126,-0.1973,0.0477,-0.0549,0.2032,-0.1144,0.0789,0.0271,-0.1051,-0.1554,-0.0072;0.1522,0.3006,-0.1546,-0.2025,0.1515,-0.2877,0.1139,-0.2554,0.1686,0.1491,-0.1527,-0.1508,-0.2943,-0.2083,-0.1602,-0.0381,0.3324,0.1166,0.1224,-0.2957,0.0634,-0.0461,-0.0377,0.0717,0.1882,0.0168,-0.1165,0.1427,-0.09,-0.2587;-0.2384,-0.0298,-0.1378,0.1958,0.0832,0.0385,0.2058,0.0383,-0.0787,0.0168,0.0975,-0.1511,-0.367,0.0354,0.054,-0.1496,0.0563,-0.1985,-0.2293,-0.1316,-0.0803,0.3907,-0.1867,0.0072,-0.2601,0.4583,-0.2057,0.0102,0.0235,0.0745;0.1384,0.0448,0.2034,-0.5556,0.1786,-0.1241,0.009,0.2041,-0.282,-0.157,-0.0262,0.2082,-0.0757,0.329,0.0227,-0.1121,0.1217,-0.2464,-0.0961,-0.0445,-0.098,0.2582,0.1094,-0.0293,0.0248,-0.1611,-0.0637,0.1851,0.1527,-0.0227;0.4255,0.0804,0.133,0.0638,0.0727,-0.0282,0.175,0.034,0.0594,-0.1446,-0.0832,-0.2198,0.3825,-0.1919,-0.191,-0.0254,0.0519,-0.1036,0.0655,-0.1899,-0.1796,0.0917,-0.0902,0.266,-0.4293,-0.0649,-0.0318,-0.1872,0.1978,0.126;-0.0119,-0.0676,-0.0264,-0.1318,-0.0559,-0.0716,0.2679,-0.3206,-0.0949,-0.1913,0.0187,-0.4508,-0.035,0.1188,0.0572,0.1509,-0.1194,0.0098,-0.2896,0.1819,0.4304,0.0111,0.157,0.0025,-0.0941,-0.2972,-0.2179,-0.0655,-0.0903,0.0738;-0.0443,0.2765,0.2118,-0.069,0.3862,0.0654,-0.0916,-0.0318,0.4028,-0.1631,0.1952,-0.1671,0.1762,0.1615,0.079,0.2028,0.0488,-0.0126,0.0634,0.1105,-0.1525,0.1044,0.2169,-0.1049,0.0659,0.2603,-0.0365,-0.0016,-0.3727,0.1627;0.0807,-0.0357,-0.1007,-0.0854,0.1551,-0.0878,-0.1266,-0.1213,-0.1594,-0.0729,0.3084,0.1939,-0.0881,-0.3163,0.0308,0.0603,-0.0086,0.0891,-0.4638,-0.3487,-0.1178,-0.0871,0.067,-0.1688,-0.1367,-0.1238,0.3061,-0.159,-0.2418,0.1608;-0.1199,0.4778,-0.0304,0.0631,-0.0741,0.1985,-0.1146,-0.0809,-0.389,0.2527,-0.1622,0.111,0.1598,-0.2245,-0.0223,-0.0402,-0.0112,-0.0517,-0.0559,0.0448,-0.0949,0.1263,0.2945,-0.0115,0.094,-0.0615,-0.4057,-0.2065,-0.0662,0.1094;0.1817,-0.0026,0.1832,-0.1421,-0.2026,0.1029,-0.086,-0.342,0.0623,0.0073,-0.0198,-0.0717,-0.1921,0.0346,-0.023,-0.2754,-0.2871,0.0788,0.0704,-0.1159,0.0504,0.0933,0.4438,0.0172,0.0511,0.3596,0.2619,-0.1287,0.2779,0.059;0.2428,-0.1324,-0.1996,0.0794,-0.062,-0.2832,-0.0671,-0.075,0.0141,0.0993,0.4082,0.0745,0.2354,0.3684,0.1213,-0.1696,0.061,0.1787,-0.0928,-0.0907,-0.0887,-0.0595,-0.0182,0.0956,0.2183,0.1122,-0.3809,-0.2774,0.0772,-0.0687;0.0015,-0.1665,-0.3461,0.1468,0.2954,-0.2973,-0.3121,-0.1769,-0.0515,0.0237,-0.1642,0.0238,-0.0522,0.0319,0.0378,-0.0823,-0.0171,0.136,0.1462,0.2781,-0.1775,0.058,0.3101,0.0546,-0.3813,-0.0888,-0.0343,0.2589,0.0539,0.0888;-0.0125,0.0834,0.0181,-0.0118,0.1592,-0.1759,-0.0019,0.0331,-0.1457,0.0365,0.3213,0.0804,0.2543,-0.329,-0.1303,0.0849,-0.0441,0.0851,-0.1068,0.3322,0.3242,0.3393,-0.0239,0.2098,0.1129,0.2176,0.191,0.1328,0.1614,-0.2639;-0.2468,0.023,-0.3068,0.1517,-0.1287,-0.1044,-0.1044,0.0628,0.0865,-0.4724,-0.1009,-0.0696,0.2015,0.0306,-0.2504,0.1728,0.0039,-0.1012,-0.0351,-0.2998,-0.0414,0.1713,0.2181,-0.2934,0.1697,-0.0219,0.0073,-0.0136,0.2487,-0.2048;0.1221,-0.018,0.0678,-0.0516,0.1738,0.2026,-0.1283,0.1842,0.0164,0.3488,-0.1308,-0.2197,0.119,0.0757,0.1655,0.2074,-0.203,0.4376,-0.181,-0.265,0.0617,0.1329,-0.0678,-0.2896,-0.1086,0.0015,-0.1067,0.2063,0.2168,-0.1411;0.2676,0.2402,-0.0094,0.0464,-0.1855,-0.0198,-0.1749,0.0435,-0.0383,-0.137,0.3405,-0.0563,-0.1435,-0.1481,0.2119,0.0225,-0.3193,-0.3233,0.1892,0.0024,0.007,-0.1755,-0.0219,-0.1865,-0.2312,-0.001,-0.2045,0.2237,-0.0587,-0.3417;0.0274,0.1784,0.2366,0.3139,0.3,-0.081,-0.0439,-0.0711,-0.0729,-0.0955,-0.1836,0.2209,-0.0335,0.2662,-0.1365,-0.2654,-0.0298,0.0591,0.0191,-0.0111,0.3488,-0.0092,-0.1111,-0.2432,-0.2077,-0.034,0.0744,-0.3172,-0.1292,-0.2935;-0.2452,-0.0357,-0.2092,-0.2318,0.2834,0.3886,0.0413,-0.0217,-0.1199,-0.3527,0.1233,0.0413,0.0385,-0.0914,0.2219,-0.1874,-0.0965,0.2693,0.3332,-0.2031,0.0958,-0.048,-0.0537,0.2768,-0.0392,-0.0447,-0.0995,-0.0916,0.0149,-0.1025;-0.1666,-0.2204,0.326,0.0212,0.0607,-0.1984,0.1554,-0.2932,0.142,-0.0592,-0.2117,0.3959,0.0797,-0.1264,0.0652,0.2126,-0.36,-0.0472,-0.1142,-0.1715,-0.1282,-0.0227,-0.0115,0.1891,0.0158,0.0826,-0.3106,0.1306,-0.0409,-0.1317;-0.277,0.175,-0.0122,-0.0796,-0.1023,0.2522,0.1016,-0.2809,0.1125,0.194,0.1867,0.0282,0.1253,0.2617,-0.1072,0.0048,0.1785,-0.0356,-0.2259,0.061,-0.2641,-0.154,0.0736,0.1407,-0.3106,-0.1104,0.1724,0.0833,0.123,-0.4174;-0.3582,0.1736,0.262,-0.169,-0.2261,-0.2481,-0.413,-0.1443,0.1673,-0.0506,0.1449,-0.088,-0.0184,-0.0653,-0.0534,-0.1654,-0.011,0.1724,0.0557,-0.0071,0.0027,0.1623,-0.3772,-0.0441,-0.1214,-0.1976,-0.0962,-0.0264,0.1566,0.2331;-0.0608,0.0393,0.1649,0.328,-0.0568,0.0108,-0.0067,0.093,-0.0255,0.1406,0.3023,0.1223,-0.1222,0.1874,-0.102,0.1994,0.113,0.0007,0.2112,-0.3922,0.3038,0.1078,0.2858,0.2855,-0.0747,-0.2098,0.0014,0.2292,-0.016,0.2009;0.1446,-0.032,0.0418,0.0899,0.0739,0.1579,-0.2678,0.0395,0.2674,-0.0773,-0.0533,0.0925,-0.3799,-0.1002,0.2589,0.3116,0.1936,-0.0648,-0.1277,0.1553,-0.009,0.1808,0.0416,0.2099,0.0463,-0.1909,-0.0684,-0.3893,0.2645,-0.1782;-0.2019,-0.0896,0.0053,-0.1752,0.0024,-0.2262,0.4225,0.2424,0.2121,0.2495,0.18,0.102,-0.0485,-0.1892,0.0462,-0.0153,-0.0409,0.058,0.2708,0.0656,-0.0277,0.0755,0.2767,-0.3211,-0.2014,-0.1312,-0.0515,-0.317,0.0941,-0.0541;-0.1298,0.1821,0.1769,0.1468,0.2247,-0.0879,0.0649,0.3089,0.0591,-0.1509,0.0568,-0.0893,-0.1469,-0.1093,-0.0731,-0.2068,-0.0173,0.1029,-0.2995,0.0818,-0.011,-0.5334,0.1781,0.0859,0.0867,0.0413,-0.1443,0.1154,0.3641,0.1153;-0.15,0.0873,0.0021,0.1417,0.2148,-0.2108,0.0091,0.0794,-0.0793,0.1936,-0.0083,-0.3539,-0.0384,0.0917,0.1338,-0.1095,-0.4194,-0.1996,0.0273,-0.1116,-0.2534,0.1113,-0.0388,0.239,0.2802,-0.2891,0.2804,-0.1346,-0.0599,-0.132;0.1072,-0.0579,-0.2497,-0.1049,0.2733,0.2754,-0.0471,-0.0947,0.2522,0.1699,0.1549,0.1428,-0.1006,0.0383,-0.5493,-0.0301,-0.3339,-0.2238,-0.0178,0.0627,0.0773,0.0153,-0.1456,-0.0711,0.0957,-0.1557,-0.1622,-0.002,0.1102,0.1698;0.0462,-0.2458,0.3358,0.1817,0.122,0.1146,0.0769,-0.2263,-0.3674,-0.102,0.2297,-0.1807,-0.1812,-0.0705,-0.2588,0.1287,0.1342,0.1832,0.2208,0.1107,-0.3567,0.0299,-0.041,-0.2264,0.1681,-0.0818,-0.0953,0.0084,0.0771,-0.1032;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end
x = x*M2;
f = max(abs(x));
f = f + fbias;
end


function f = Rotated_Rochenbrock(x)
% Rotated Rochenbrock
global M
[ps,D]=size(x);
fbias = 0;
M1 = [[0.0634,0.0567,-0.027,0.5037,-0.1723,0.1864,0.0073,-0.331,0.0427,0.0702,0.0033,-0.1497,0.1037,-0.266,-0.0958,0.0316,0.2379,0.5919,0.3364,0.2339,-0.5839,0.3541,0.153,-0.0303,-0.254,0.3157,-0.3515,-0.3048,-0.0602,0.1478;-0.153,0.1836,-0.1434,-0.0304,-0.2405,-0.0345,0.0708,-0.3382,0.574,-0.3,-0.0118,-0.2028,0.1215,0.2763,-0.363,-0.4366,0.2545,0.0187,-0.088,-0.1261,0.1435,0.1647,-0.0062,-0.8468,-0.2766,-0.0723,-0.0401,0.0044,0.0192,-0.4171;-0.0946,-0.1686,-0.1382,0.334,-0.0458,-0.1513,0.1047,0.2763,0.3135,-0.0142,-0.2115,0.2479,0.0617,-0.1012,0.6765,-0.2376,0.2242,-0.1048,0.305,0.4018,-0.032,-0.0858,-0.2679,-0.1195,-0.0407,-0.405,0.015,0.1367,0.289,-0.2633;0.0797,-0.2903,-0.1571,0.1481,-0.314,0.1483,-0.0964,0.3911,-0.004,0.1017,-0.1701,-0.1593,0.1884,0.2973,-0.2498,0.3578,-0.1655,0.1099,-0.0996,0.5365,0.6679,0.1607,0.0302,-0.0084,-0.186,0.172,0.5065,-0.0182,-0.5131,0.0914;-0.391,-0.4052,-0.2928,-0.0334,0.1677,-0.2175,-0.0283,0.6093,-0.1291,0.0154,0.2668,0.0713,-0.0883,0.2002,0.214,-0.2896,-0.2252,-0.0121,-0.4319,-0.1021,0.176,0.8896,0.2969,-0.2323,0.2672,-0.0187,-0.3941,0.071,-0.5007,-0.07;0.1164,-0.1241,0.0017,-0.1166,-0.2871,0.3832,-0.0232,-0.2324,0.3942,0.1802,0.1154,-0.2814,-0.4764,-0.3277,-0.1524,-0.476,-0.2608,-0.3429,0.4188,0.1359,0.5001,0.2248,0.7585,0.142,0.2312,0.1882,0.2215,-0.5378,0.1615,0.3265;0.2808,-0.2046,0.5017,-0.0998,0.3713,-0.2847,0.5037,-0.0311,0.1392,0.6209,0.366,-0.1891,0.0313,-0.2699,0.0818,-0.3026,0.308,0.0578,-0.026,-0.084,0.0049,-0.1337,-0.225,0.2672,-0.3145,0.1311,0.0636,-0.1361,-0.6162,-0.5223;0.2181,-0.0157,-0.0314,-0.2983,-0.6348,-0.0804,-0.0576,0.1963,0.1817,0.1181,-0.0189,0.3376,-0.3502,-0.428,-0.2196,-0.1762,-0.1422,0.2216,0.0615,0.2011,-0.0871,-0.2959,-0.2506,-0.0251,0.1893,0.0504,-0.1499,0.4605,-0.1994,0.3048;-0.0498,0.0941,0.2365,-0.0331,0.1487,0.1668,-0.725,0.1934,0.1608,0.4743,-0.4571,0.4222,-0.4218,-0.2385,-0.0837,0.0406,0.2162,-0.1377,-0.5627,0.1286,-0.2314,-0.1006,0.2975,-0.0167,0.0518,0.2825,0.0297,-0.189,0.0574,-0.3345;-0.1393,0.2221,-0.1201,-0.3161,0.0512,0.2754,-0.3593,-0.443,0.1501,0.302,-0.4705,0.2727,0.4229,0.0241,0.5458,-0.2455,0.046,0.0535,-0.1943,-0.0388,0.253,0.154,-0.268,-0.0313,-0.2632,0.1871,-0.2473,0.203,-0.2886,0.6311;0.2207,-0.1127,-0.0722,-0.0359,0.1016,0.208,0.2199,-0.6066,-0.2139,-0.0627,0.046,0.0928,-0.1125,0.6482,0.1853,-0.6908,0.1702,-0.1758,-0.1474,0.0219,-0.5167,0.0811,-0.1861,0.0354,0.0525,0.5255,0.4733,0.0288,-0.0506,-0.0724;0.1523,0.3589,0.4031,-0.6708,0.0845,-0.1188,0.1671,-0.0959,0.1734,-0.1772,-0.0589,0.1117,-0.0619,0.564,0.4179,0.0746,0.1466,0.3246,0.0755,0.5198,0.2303,-0.3316,0.5117,0.2855,0.2007,-0.1473,-0.4626,-0.0603,-0.499,-0.0197;0.3144,0.0916,0.2413,0.3082,-0.0158,-0.1084,-0.3337,-0.0977,-0.2342,0.199,0.1187,-0.7064,-0.2967,-0.0389,0.4072,0.1088,-0.0931,-0.2537,0.1777,-0.0119,0.014,-0.0801,0.1641,-0.4028,0.1856,-0.416,0.1253,0.4275,-0.0868,0.1357;0.6246,-0.0212,0.1579,0.02,0.0135,-0.1914,0.0531,0.1648,-0.0256,-0.5205,0.2737,0.3727,0.5056,-0.5061,0.1762,-0.1609,0.0912,-0.3194,0.1008,0.172,0.1117,0.1528,-0.0728,-0.3045,0.343,0.3376,-0.0326,-0.3946,-0.1317,-0.2319;-0.3347,0.208,-0.0645,0.4183,0.0642,0.1753,-0.1108,-0.4374,-0.3935,-0.286,0.5691,0.1018,-0.4549,0.0636,-0.1066,0.0198,0.0777,-0.0295,-0.1244,0.2578,0.576,-0.2258,-0.4057,0.1576,-0.0113,0.1485,-0.0555,-0.3551,-0.224,-0.1254;-0.1985,0.4533,-0.104,0.0326,0.0913,-0.569,-0.2729,0.4099,-0.0827,0.1901,-0.0919,-0.0882,-0.2557,0.2568,0.1249,-0.2379,0.2429,0.2646,0.2247,-0.0263,0.0065,0.2445,-0.2119,0.0023,0.3212,0.2758,0.277,-0.5189,0.1805,0.2359;-0.3194,-0.1816,-0.0621,-0.231,-0.1636,0.0627,-0.4456,0.1778,0.3625,-0.1798,0.5556,-0.4202,0.3934,-0.0039,0.4677,0.1122,-0.2192,0.31,0.0126,0.0667,-0.1537,-0.7071,-0.219,0.142,0.2199,0.1742,0.2031,-0.3337,0.0407,-0.3338;0.0529,-0.3061,0.4045,0.1704,-0.0363,-0.1734,0.1608,0.2399,0.7539,-0.2758,-0.292,0.0455,-0.2602,0.293,0.2111,0.1236,-0.189,-0.2211,-0.1775,-0.1485,-0.0812,0.1496,-0.4782,0.206,0.1998,0.0457,-0.1844,-0.1962,-0.0271,0.2167;-0.121,0.1005,0.2047,-0.4727,-0.3383,-0.2948,0.0007,-0.0731,-0.4137,-0.3126,-0.2672,-0.3758,-0.0445,-0.2055,-0.0388,0.1931,-0.2694,-0.3634,0.1165,0.5595,-0.1386,0.4816,-0.5654,0.0681,-0.3043,0.0262,-0.4209,0.0208,0.3257,-0.1533;-0.4493,0.2447,0.1674,-0.1343,-0.2745,0.0395,-0.0064,-0.1051,-0.3108,-0.6935,-0.5264,0.0073,-0.0912,-0.4356,0.1255,-0.2502,-0.1316,0.2137,-0.3316,-0.4853,0.1737,-0.1018,0.2616,0.1676,0.0754,0.0127,0.5482,0.4163,-0.3082,-0.279;0.0556,0.3762,0.1717,0.3889,-0.5057,-0.1594,-0.0567,-0.278,-0.1244,0.4403,-0.0725,0.3321,0.5397,0.564,-0.3762,-0.1796,-0.2121,-0.0666,0.2303,-0.1002,0.0118,0.1817,-0.1839,0.5152,0.3387,-0.3369,-0.1593,0.1454,-0.1364,-0.395;-0.45,0.2384,-0.3702,0.1521,-0.0527,-0.3783,-0.3215,0.0891,0.2221,-0.1731,0.2656,-0.0533,0.2019,-0.1445,-0.3418,0.3055,0.5902,-0.681,0.1668,0.1866,-0.2286,-0.0813,0.4315,0.3948,-0.0617,0.2846,-0.1679,0.2737,-0.3657,-0.1485;-0.5093,0.0551,0.5574,0.1912,-0.5549,0.1726,0.222,0.3923,-0.2627,0.3153,0.0468,0.3175,0.1559,0.0849,0.1815,-0.008,-0.3377,-0.3527,0.1522,-0.3804,-0.0768,-0.2415,0.1064,-0.299,-0.5469,0.2121,-0.0363,-0.2715,-0.0147,0.1938;0.1115,0.6437,0.1166,0.3677,0.299,-0.0605,-0.0122,0.365,0.061,-0.1767,-0.2188,-0.089,0.1069,-0.1514,-0.3639,-0.5315,-0.6229,-0.1554,-0.3021,0.4387,-0.3377,-0.2878,-0.1208,0.2296,-0.2528,0.1305,-0.0085,-0.1097,-0.0759,0.2726;-0.2716,-0.3487,0.0198,0.0602,-0.0167,0.098,0.319,-0.0365,-0.3544,-0.1563,-0.6094,-0.4293,0.1029,0.0561,-0.2172,-0.2336,0.4703,0.1572,-0.0334,0.2842,0.1147,-0.2226,-0.1058,-0.0387,0.839,0.2203,-0.3735,-0.3205,0.3091,0.1012;-0.2848,-0.3868,0.2895,-0.1028,0.5798,0.619,-0.3523,0.2165,-0.2116,-0.2331,-0.02,0.1102,-0.1272,0.1002,-0.2801,-0.108,0.259,-0.0386,0.3754,-0.0238,-0.1776,0.1103,-0.3209,0.2815,0.0747,-0.2609,0.2653,-0.0996,-0.5574,0.1796;-0.4782,0.4535,0.0214,-0.2726,0.1309,0.3229,0.3891,-0.0263,0.2669,0.1357,0.04,0.0586,0.1618,-0.1563,0.1675,0.3833,-0.4748,-0.0471,0.1214,0.249,0.0436,0.1977,-0.1038,-0.375,0.4276,0.6124,0.1973,0.2323,-0.0788,-0.3383;0.1473,0.6225,0.127,-0.0553,-0.4618,0.6691,0.1878,0.6053,0.1994,0.0676,0.1908,-0.0887,0.1075,-0.0388,-0.0477,-0.1971,0.5972,0.0263,-0.4166,-0.021,0.1345,0.43,-0.0709,0.3147,0.2689,-0.1686,0.2133,-0.0269,0.3164,0.0222;0.359,-0.0721,-0.1565,-0.0243,0.3498,0.5227,-0.3677,0.3839,-0.011,-0.1039,-0.1776,-0.1382,-0.0928,-0.1825,0.0703,-0.0572,0.0626,0.1562,0.4774,-0.3839,0.0161,0.0506,-0.0988,0.1442,-0.1716,0.6623,-0.425,0.5839,0.0905,-0.4033;-0.0684,-0.2598,0.6168,0.2563,0.2366,0.0309,-0.2393,0.0987,0.2818,-0.1492,0.4573,0.0322,0.3832,0.289,-0.1717,-0.0916,0.039,0.4638,0.0137,0.0927,0.3184,0.2551,0.0045,0.0185,-0.187,0.1746,0.2572,0.5741,0.5359,0.2261;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end
x = x*M2;
f=sum(100.*(x(1,1:D-1).^2-x(1,2:D)).^2+(x(1,1:D-1)-1).^2,2);
f = f + fbias;
end


function f = Rotated_Ackley(x)
% Rotated Ackley
global M
[ps,D]=size(x);
fbias = 0;
M1 = [[-0.0196,0.3069,-0.139,0.0233,0.1644,-0.1202,0.1849,-0.2882,-0.1735,0.0279,0.0149,0.1334,0.0129,0.1532,0.2544,0.3743,-0.0221,-0.1054,0.1828,-0.0025,0.0334,-0.1686,-0.2243,-0.1457,0.0199,0.1116,0.1739,-0.0556,0.4217,0.2816;0.1939,0.2103,-0.0582,0.2685,-0.0884,0.1261,0.3435,-0.1173,0.2316,-0.1708,0.0372,0.2069,0.0024,-0.0446,0.2317,-0.3044,-0.0261,0.2046,-0.1037,0.104,-0.1261,0.3089,-0.0391,-0.1307,0.1657,-0.3051,0.0581,0.2883,0.0312,0.0995;0.0854,0.288,-0.1274,-0.0792,-0.2168,-0.1039,0.1178,0.2275,-0.0862,-0.1717,-0.0377,0.1056,-0.2707,0.209,-0.2801,0.2857,-0.2997,0.4368,-0.0075,0.126,-0.1973,0.0477,-0.0549,0.2032,-0.1144,0.0789,0.0271,-0.1051,-0.1554,-0.0072;0.1522,0.3006,-0.1546,-0.2025,0.1515,-0.2877,0.1139,-0.2554,0.1686,0.1491,-0.1527,-0.1508,-0.2943,-0.2083,-0.1602,-0.0381,0.3324,0.1166,0.1224,-0.2957,0.0634,-0.0461,-0.0377,0.0717,0.1882,0.0168,-0.1165,0.1427,-0.09,-0.2587;-0.2384,-0.0298,-0.1378,0.1958,0.0832,0.0385,0.2058,0.0383,-0.0787,0.0168,0.0975,-0.1511,-0.367,0.0354,0.054,-0.1496,0.0563,-0.1985,-0.2293,-0.1316,-0.0803,0.3907,-0.1867,0.0072,-0.2601,0.4583,-0.2057,0.0102,0.0235,0.0745;0.1384,0.0448,0.2034,-0.5556,0.1786,-0.1241,0.009,0.2041,-0.282,-0.157,-0.0262,0.2082,-0.0757,0.329,0.0227,-0.1121,0.1217,-0.2464,-0.0961,-0.0445,-0.098,0.2582,0.1094,-0.0293,0.0248,-0.1611,-0.0637,0.1851,0.1527,-0.0227;0.4255,0.0804,0.133,0.0638,0.0727,-0.0282,0.175,0.034,0.0594,-0.1446,-0.0832,-0.2198,0.3825,-0.1919,-0.191,-0.0254,0.0519,-0.1036,0.0655,-0.1899,-0.1796,0.0917,-0.0902,0.266,-0.4293,-0.0649,-0.0318,-0.1872,0.1978,0.126;-0.0119,-0.0676,-0.0264,-0.1318,-0.0559,-0.0716,0.2679,-0.3206,-0.0949,-0.1913,0.0187,-0.4508,-0.035,0.1188,0.0572,0.1509,-0.1194,0.0098,-0.2896,0.1819,0.4304,0.0111,0.157,0.0025,-0.0941,-0.2972,-0.2179,-0.0655,-0.0903,0.0738;-0.0443,0.2765,0.2118,-0.069,0.3862,0.0654,-0.0916,-0.0318,0.4028,-0.1631,0.1952,-0.1671,0.1762,0.1615,0.079,0.2028,0.0488,-0.0126,0.0634,0.1105,-0.1525,0.1044,0.2169,-0.1049,0.0659,0.2603,-0.0365,-0.0016,-0.3727,0.1627;0.0807,-0.0357,-0.1007,-0.0854,0.1551,-0.0878,-0.1266,-0.1213,-0.1594,-0.0729,0.3084,0.1939,-0.0881,-0.3163,0.0308,0.0603,-0.0086,0.0891,-0.4638,-0.3487,-0.1178,-0.0871,0.067,-0.1688,-0.1367,-0.1238,0.3061,-0.159,-0.2418,0.1608;-0.1199,0.4778,-0.0304,0.0631,-0.0741,0.1985,-0.1146,-0.0809,-0.389,0.2527,-0.1622,0.111,0.1598,-0.2245,-0.0223,-0.0402,-0.0112,-0.0517,-0.0559,0.0448,-0.0949,0.1263,0.2945,-0.0115,0.094,-0.0615,-0.4057,-0.2065,-0.0662,0.1094;0.1817,-0.0026,0.1832,-0.1421,-0.2026,0.1029,-0.086,-0.342,0.0623,0.0073,-0.0198,-0.0717,-0.1921,0.0346,-0.023,-0.2754,-0.2871,0.0788,0.0704,-0.1159,0.0504,0.0933,0.4438,0.0172,0.0511,0.3596,0.2619,-0.1287,0.2779,0.059;0.2428,-0.1324,-0.1996,0.0794,-0.062,-0.2832,-0.0671,-0.075,0.0141,0.0993,0.4082,0.0745,0.2354,0.3684,0.1213,-0.1696,0.061,0.1787,-0.0928,-0.0907,-0.0887,-0.0595,-0.0182,0.0956,0.2183,0.1122,-0.3809,-0.2774,0.0772,-0.0687;0.0015,-0.1665,-0.3461,0.1468,0.2954,-0.2973,-0.3121,-0.1769,-0.0515,0.0237,-0.1642,0.0238,-0.0522,0.0319,0.0378,-0.0823,-0.0171,0.136,0.1462,0.2781,-0.1775,0.058,0.3101,0.0546,-0.3813,-0.0888,-0.0343,0.2589,0.0539,0.0888;-0.0125,0.0834,0.0181,-0.0118,0.1592,-0.1759,-0.0019,0.0331,-0.1457,0.0365,0.3213,0.0804,0.2543,-0.329,-0.1303,0.0849,-0.0441,0.0851,-0.1068,0.3322,0.3242,0.3393,-0.0239,0.2098,0.1129,0.2176,0.191,0.1328,0.1614,-0.2639;-0.2468,0.023,-0.3068,0.1517,-0.1287,-0.1044,-0.1044,0.0628,0.0865,-0.4724,-0.1009,-0.0696,0.2015,0.0306,-0.2504,0.1728,0.0039,-0.1012,-0.0351,-0.2998,-0.0414,0.1713,0.2181,-0.2934,0.1697,-0.0219,0.0073,-0.0136,0.2487,-0.2048;0.1221,-0.018,0.0678,-0.0516,0.1738,0.2026,-0.1283,0.1842,0.0164,0.3488,-0.1308,-0.2197,0.119,0.0757,0.1655,0.2074,-0.203,0.4376,-0.181,-0.265,0.0617,0.1329,-0.0678,-0.2896,-0.1086,0.0015,-0.1067,0.2063,0.2168,-0.1411;0.2676,0.2402,-0.0094,0.0464,-0.1855,-0.0198,-0.1749,0.0435,-0.0383,-0.137,0.3405,-0.0563,-0.1435,-0.1481,0.2119,0.0225,-0.3193,-0.3233,0.1892,0.0024,0.007,-0.1755,-0.0219,-0.1865,-0.2312,-0.001,-0.2045,0.2237,-0.0587,-0.3417;0.0274,0.1784,0.2366,0.3139,0.3,-0.081,-0.0439,-0.0711,-0.0729,-0.0955,-0.1836,0.2209,-0.0335,0.2662,-0.1365,-0.2654,-0.0298,0.0591,0.0191,-0.0111,0.3488,-0.0092,-0.1111,-0.2432,-0.2077,-0.034,0.0744,-0.3172,-0.1292,-0.2935;-0.2452,-0.0357,-0.2092,-0.2318,0.2834,0.3886,0.0413,-0.0217,-0.1199,-0.3527,0.1233,0.0413,0.0385,-0.0914,0.2219,-0.1874,-0.0965,0.2693,0.3332,-0.2031,0.0958,-0.048,-0.0537,0.2768,-0.0392,-0.0447,-0.0995,-0.0916,0.0149,-0.1025;-0.1666,-0.2204,0.326,0.0212,0.0607,-0.1984,0.1554,-0.2932,0.142,-0.0592,-0.2117,0.3959,0.0797,-0.1264,0.0652,0.2126,-0.36,-0.0472,-0.1142,-0.1715,-0.1282,-0.0227,-0.0115,0.1891,0.0158,0.0826,-0.3106,0.1306,-0.0409,-0.1317;-0.277,0.175,-0.0122,-0.0796,-0.1023,0.2522,0.1016,-0.2809,0.1125,0.194,0.1867,0.0282,0.1253,0.2617,-0.1072,0.0048,0.1785,-0.0356,-0.2259,0.061,-0.2641,-0.154,0.0736,0.1407,-0.3106,-0.1104,0.1724,0.0833,0.123,-0.4174;-0.3582,0.1736,0.262,-0.169,-0.2261,-0.2481,-0.413,-0.1443,0.1673,-0.0506,0.1449,-0.088,-0.0184,-0.0653,-0.0534,-0.1654,-0.011,0.1724,0.0557,-0.0071,0.0027,0.1623,-0.3772,-0.0441,-0.1214,-0.1976,-0.0962,-0.0264,0.1566,0.2331;-0.0608,0.0393,0.1649,0.328,-0.0568,0.0108,-0.0067,0.093,-0.0255,0.1406,0.3023,0.1223,-0.1222,0.1874,-0.102,0.1994,0.113,0.0007,0.2112,-0.3922,0.3038,0.1078,0.2858,0.2855,-0.0747,-0.2098,0.0014,0.2292,-0.016,0.2009;0.1446,-0.032,0.0418,0.0899,0.0739,0.1579,-0.2678,0.0395,0.2674,-0.0773,-0.0533,0.0925,-0.3799,-0.1002,0.2589,0.3116,0.1936,-0.0648,-0.1277,0.1553,-0.009,0.1808,0.0416,0.2099,0.0463,-0.1909,-0.0684,-0.3893,0.2645,-0.1782;-0.2019,-0.0896,0.0053,-0.1752,0.0024,-0.2262,0.4225,0.2424,0.2121,0.2495,0.18,0.102,-0.0485,-0.1892,0.0462,-0.0153,-0.0409,0.058,0.2708,0.0656,-0.0277,0.0755,0.2767,-0.3211,-0.2014,-0.1312,-0.0515,-0.317,0.0941,-0.0541;-0.1298,0.1821,0.1769,0.1468,0.2247,-0.0879,0.0649,0.3089,0.0591,-0.1509,0.0568,-0.0893,-0.1469,-0.1093,-0.0731,-0.2068,-0.0173,0.1029,-0.2995,0.0818,-0.011,-0.5334,0.1781,0.0859,0.0867,0.0413,-0.1443,0.1154,0.3641,0.1153;-0.15,0.0873,0.0021,0.1417,0.2148,-0.2108,0.0091,0.0794,-0.0793,0.1936,-0.0083,-0.3539,-0.0384,0.0917,0.1338,-0.1095,-0.4194,-0.1996,0.0273,-0.1116,-0.2534,0.1113,-0.0388,0.239,0.2802,-0.2891,0.2804,-0.1346,-0.0599,-0.132;0.1072,-0.0579,-0.2497,-0.1049,0.2733,0.2754,-0.0471,-0.0947,0.2522,0.1699,0.1549,0.1428,-0.1006,0.0383,-0.5493,-0.0301,-0.3339,-0.2238,-0.0178,0.0627,0.0773,0.0153,-0.1456,-0.0711,0.0957,-0.1557,-0.1622,-0.002,0.1102,0.1698;0.0462,-0.2458,0.3358,0.1817,0.122,0.1146,0.0769,-0.2263,-0.3674,-0.102,0.2297,-0.1807,-0.1812,-0.0705,-0.2588,0.1287,0.1342,0.1832,0.2208,0.1107,-0.3567,0.0299,-0.041,-0.2264,0.1681,-0.0818,-0.0953,0.0084,0.0771,-0.1032;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end
x = x*M2;
f = 0;
f=sum(x.^2,2);
f=20-20.*exp(-0.2.*sqrt(f./D))-exp(sum(cos(2.*pi.*x),2)./D)+exp(1);
f = f + fbias;
end

function f = Rotated_Griewank(x)
% Rotated Griewank
global M
[ps,D]=size(x);
fbias = 0;
M1 = [[0.1349,-0.4057,0.3513,-0.0086,0.3535,0.2095,0.1764,-0.4694,-0.1637,-0.107,-0.1965,0.1681,0.0204,0.2295,-0.2054,-0.2022,-0.2927,0.4514,0.1165,0.6857,-0.0794,0.5229,-0.1763,-0.5776,0.5668,0.2081,0.0119,-0.7944,0.3821,-0.4667;0.2635,-0.0744,0.1318,0.3304,0.1504,-0.3233,0.3156,0.3591,-0.805,-0.2856,-0.0319,-0.4872,0.1264,-0.1108,-0.6551,-0.6522,-0.0374,-0.1733,0.007,-0.3174,0.4259,0.0547,0.3867,-0.3015,0.2675,0.6241,-0.5671,-0.1124,0.223,0.2673;-0.2095,0.0025,0.1812,-0.5098,0.4733,0.1304,-0.0393,0.2453,-0.2511,-0.1615,0.2986,0.5754,-0.2355,-0.1076,-0.0238,0.1511,0.112,-0.8648,-0.5549,-0.6451,0.0664,-0.105,0.4681,-0.2684,0.4637,-0.5532,0.6301,-0.115,-0.1699,0.2679;0.3111,0.3246,-0.1877,0.0711,0.1386,0.0715,0.427,0.3665,0.4035,-0.4656,0.735,0.4823,-0.0822,0.0507,-0.0435,0.3297,0.0942,-0.2801,0.1439,0.3341,0.2157,0.1275,-0.1967,0.3725,0.4147,-0.4366,0.4588,0.2075,-0.0229,-0.5423;-0.6262,0.1838,-0.3268,0.8157,-0.6696,0.2841,0.3132,-0.1687,-0.4178,0.063,-0.3591,-0.1225,0.1229,-0.1908,-0.5232,-0.1692,-0.1152,-0.6313,-0.1282,0.367,-0.1497,-0.1748,-0.024,0.1326,-0.1931,-0.0038,0.5671,0.5666,0.2578,-0.6088;-0.768,0.1896,-0.2122,0.4745,-0.3547,0.1388,-0.4174,0.2938,0.2618,-0.138,0.1706,-0.1217,-0.6894,0.5854,0.4678,-0.1942,0.0326,0.1641,0.1646,-0.3896,-0.4345,0.4002,0.6511,-0.1226,0.1912,0.712,-0.362,0.0027,0.0637,0.3216;0.0349,-0.298,0.7997,-0.1811,-0.6262,0.0764,-0.2273,0.5492,0.3337,-0.0268,0.1636,0.1493,0.3987,-0.4158,-0.1089,0.0646,-0.4406,0.2067,0.3926,-0.0697,-0.3283,-0.0011,0.6524,0.0511,0.0233,0.2982,0.6582,-0.3656,0.1859,-0.0858;-0.421,-0.0116,-0.0812,0.0327,-0.491,-0.2247,-0.5409,0.1575,-0.0465,0.1384,-0.1055,-0.5763,0.2965,0.3072,0.4556,0.3519,0.106,-0.5732,0.7577,-0.1558,0.4001,-0.0835,-0.6961,-0.1637,0.6394,-0.0689,0.1003,-0.3499,0.1589,0.2195;0.4218,-0.0451,-0.6095,0.3083,-0.0774,0.1646,-0.0361,-0.6155,0.1392,-0.7189,-0.5162,-0.0534,-0.0945,-0.1039,-0.0768,-0.1013,-0.17,-0.3459,0.3384,-0.0563,-0.0983,0.2013,-0.0752,0.174,0.0895,-0.0579,0.4491,-0.0795,-0.5726,0.2401;0.1699,0.5875,-0.0588,-0.2001,-0.6823,0.0833,0.4618,-0.2289,-0.4017,-0.0606,0.2808,-0.5252,0.057,0.4204,0.4314,0.8503,-0.3183,0.1095,-0.1858,-0.237,-0.0182,-0.0791,-0.3819,-0.6015,0.0767,0.3934,0.3138,0.1903,-0.1152,0.3898;0.5155,-0.0045,0.0618,0.668,-0.0389,0.4071,0.1814,0.3378,-0.421,0.4507,-0.1711,0.2766,-0.3575,0.1264,-0.1486,-0.1837,0.6246,0.6587,0.1899,-0.1049,0.0423,0.5428,-0.5704,-0.4198,0.0351,0.0061,0.5925,-0.0401,-0.0927,-0.1564;-0.2463,0.3685,0.0367,-0.3621,0.1167,0.5486,0.1595,-0.2351,-0.3647,-0.4503,-0.1691,-0.2795,0.3137,-0.5412,0.4979,0.2266,0.7479,0.3144,0.4121,-0.2937,0.348,-0.1076,0.4383,0.0757,-0.2838,-0.125,-0.2066,0.1864,0.2916,-0.3444;0.1,-0.3241,0.1949,-0.1626,-0.581,-0.0348,0.2745,-0.3745,-0.796,0.1935,0.2042,0.1424,0.266,0.2164,0.3457,0.0109,-0.3331,0.0797,0.346,-0.0453,0.3147,-0.1946,0.4692,-0.1918,-0.4195,-0.992,-0.0372,0.023,-0.2258,-0.315;-0.2629,0.3141,-0.4341,-0.2945,-0.0175,-0.5212,0.6996,0.7538,-0.3188,-0.1548,-0.7362,0.0685,-0.153,0.2155,0.0964,0.004,0.082,-0.4002,-0.1663,0.4904,-0.5594,-0.2474,-0.0791,0.3791,-0.3175,-0.463,0.1707,-0.6192,0.0054,0.1678;-0.3199,0.2219,-0.2213,-0.2373,0.2292,0.0094,-0.6204,0.384,-0.2784,-0.254,0.4175,-0.6371,0.1849,-0.1197,0.1765,-0.5461,-0.3588,0.3434,0.12,0.2099,-0.3332,-0.0951,0.0084,0.5042,-0.0408,-0.3443,0.5975,0.4025,-0.8468,-0.4012;-0.0308,0.3228,1.0046,0.4805,-0.1624,-0.3264,0.2259,-0.5916,0.2985,-0.0263,-0.1039,-0.3454,-0.2553,0.3815,-0.4795,-0.2362,0.2993,0.1611,-0.2626,-0.5308,0.0894,-0.7676,0.6916,0.1356,0.3899,-0.1254,0.386,0.2732,-0.1756,-0.3273;-0.0052,0.1416,-0.6571,-0.0584,0.6556,-0.5187,-0.4733,-0.3519,-0.0789,0.0185,0.1908,-0.0762,-0.2812,0.1155,-0.5108,0.1259,-0.017,0.273,0.2168,0.7058,-0.2549,0.1253,0.4638,-0.0023,-0.2892,-0.2811,0.3237,-0.2342,0.1411,-0.0662;0.1863,0.2609,-0.2146,0.4789,-0.4396,-0.1972,-0.3573,-0.3317,-0.2187,0.0709,0.0716,0.2226,0.1918,0.2682,0.2235,-0.4683,0.3479,-0.0513,-0.8751,0.0519,-0.4502,0.3134,0.0129,0.5511,0.3304,0.5124,0.0135,-0.0881,0.723,0.2051;-0.1157,-0.1428,-0.242,-0.1288,0.0138,-0.2271,-0.1255,0.4459,0.0385,-0.3268,-0.6356,0.3376,0.2413,0.7487,-0.3411,0.1102,-0.2234,-0.0513,0.3196,0.1675,-0.6097,-0.021,-0.455,-0.1474,0.5531,-0.3691,-0.0905,0.8876,0.4073,0.1588;-0.0361,0.2004,0.1483,-0.1022,0.2396,0.1727,0.6783,-0.3698,0.226,-0.1925,0.2722,0.7511,0.7203,0.0449,0.1919,-0.3816,0.1766,-0.3302,0.6452,0.7047,0.3688,-0.4687,-0.1506,-0.208,0.0148,0.3273,0.2232,0.2743,0.1093,0.8654;0.2829,0.2555,0.1953,-0.2658,0.0147,0.086,-0.7988,0.5129,0.4968,-0.5988,0.3359,0.333,-0.0211,0.3398,0.1908,-0.3884,0.1925,-0.1561,-0.2174,-0.1453,0.2633,-0.2032,-0.5175,-0.6254,-0.3261,0.4431,0.2215,-0.0927,-0.0901,-0.4311;0.158,-0.271,-0.3127,-0.2177,0.1958,-0.2446,0.3406,-0.0445,-0.4554,0.1959,-0.0305,0.3965,-0.1764,-0.0827,0.0237,0.4937,0.3171,0.0444,0.5863,0.1565,-0.2841,-0.6579,0.1811,0.1549,0.2632,0.9316,-0.1744,-0.4117,-0.8765,-0.374;-0.3909,-0.2159,-1.0295,-0.0304,-0.4629,-0.5959,0.3899,-0.3209,0.32,-0.1231,0.0713,0.3775,-0.4273,-0.1162,-0.447,-0.4933,0.0279,0.1946,-0.1548,-0.6904,0.2728,-0.4407,-0.1995,-0.3181,0.2653,-0.3802,0.0927,0.0224,0.2716,0.0878;0.4574,0.097,0.0009,-0.6295,0.0207,-0.1937,0.0087,-0.1002,-0.1878,0.4348,-0.4519,0.2409,-0.1062,0.3509,-0.1055,-0.3934,-0.3436,0.032,0.4195,0.141,1.0034,0.3434,-0.0055,0.4003,-0.2224,0.05,0.049,0.3569,0.3492,-0.3001;0.092,-0.6165,-0.3934,0.1417,-0.2543,1.2387,-0.3247,0.2099,0.1459,-0.2988,-0.0098,-0.3414,-0.0961,0.3524,0.252,0.7007,0.1295,0.0316,-0.1867,0.5227,0.3269,-0.0868,0.237,0.1818,0.2349,-0.1644,0.119,-0.168,0.5449,0.3167;0.3185,-0.0952,0.0371,0.5913,0.1955,-0.3561,-0.3722,-0.0227,-0.4073,-0.5572,-0.2703,0.0193,-0.4411,-0.6701,0.4909,0.2451,-0.7105,0.737,0.156,0.206,0.4929,-0.3205,-0.4438,0.0631,0.2603,0.2914,-0.0427,0.1621,-0.1104,-0.0642;-0.2068,-0.2649,0.5176,-0.0254,0.2401,0.3154,-0.0962,-0.213,-0.298,-0.2441,0.5174,-0.0534,-0.2633,0.3048,-0.491,0.1164,-0.4184,-0.3548,0.408,-0.5142,-0.1003,-0.2974,-0.2074,0.5677,-0.3415,0.1965,0.2312,-0.275,0.6195,0.078;0.2562,0.4731,-0.0769,0.6447,0.4665,0.5908,0.1254,0.3745,-0.2303,0.3639,-0.4144,0.5876,0.7029,0.02,-0.2557,-0.0348,-0.5558,0.0215,0.5017,-0.3712,-0.0025,-0.3666,0.1196,-0.0974,0.1029,-0.1855,0.1649,-0.6418,0.3476,-0.3617;-0.6673,0.2588,0.3316,-0.1549,-0.3565,0.4502,-0.2365,-0.3885,0.0545,-0.2114,-0.275,0.6414,0.149,0.0521,-0.8118,0.1486,0.402,0.4305,-0.2686,0.1177,0.0839,0.0985,0.1781,0.2333,-0.1008,-0.0149,-0.4078,-0.4257,-0.2577,0.3215;0.4433,0.6178,-0.1228,-0.4284,-0.2711,0.2202,-0.1691,-0.1268,-0.2446,0.2978,-0.0396,0.4271,-0.5127,-0.8914,0.0397,-0.432,0.3154,0.2216,0.4029,0.3318,-0.3963,-0.4873,-0.1828,-0.4125,0.1913,0.0515,-0.5053,0.3363,-0.4558,-0.2667;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end
x = x*M2;
f=1;
for i=1:D
    f=f*cos(x(i)/sqrt(i));
end
f=sum(x.^2)/4000-f+1;
f = f + fbias;
end

function f = Rotated_Rastrigin(x)
% Rotated Rastrigin
global M
[ps,D]=size(x);
fbias = 0;
o = [[1.9005,-1.5644,-0.9788,-2.2536,2.499,-3.2853,0.9759,-3.6661,0.0985,-3.2465,3.806,-2.6834,-1.3701,4.1821,2.4856,-4.2237,3.3653,2.1532,-3.0929,4.3105,-2.9861,3.4936,-2.7289,-4.1266,-2.59,1.3124,-1.799,-1.189,-0.1053,-3.1074,-3.9641,-4.3387,3.0705,3.3205,-3.8178,-1.498,-4.3807,2.711,-3.7956,-2.3627,4.0086,-1.3728,-4.4362,-2.9183,-2.2457,0.3065,-0.8924,-3.2364,-1.2521,2.7198,-3.9787,3.0678,-4.24,-3.958,3.9479,0.2203,-2.6124,2.6498,-2.3256,-1.5383,3.476,2.4462,2.4575,3.7409,-2.4887,3.8555,-1.1426,1.3389,2.2323,2.3137,-4.337,3.926,3.5905,-1.2858,-2.0113,2.9087,3.9278,1.0812,-0.7461,3.474,2.3036,-3.3781,-0.4491,0.9402,-3.0583,-4.2165,-2.3604,0.8364,1.4773,-2.7292,-1.5904,0.7696,0.5164,2.6576,-0.5427,1.0358,0.6926,-4.2775,-1.5911,-3.5775;]];
o = o(1:D);
M1 = [[0.0634,0.0567,-0.027,0.5037,-0.1723,0.1864,0.0073,-0.331,0.0427,0.0702,0.0033,-0.1497,0.1037,-0.266,-0.0958,0.0316,0.2379,0.5919,0.3364,0.2339,-0.5839,0.3541,0.153,-0.0303,-0.254,0.3157,-0.3515,-0.3048,-0.0602,0.1478;-0.153,0.1836,-0.1434,-0.0304,-0.2405,-0.0345,0.0708,-0.3382,0.574,-0.3,-0.0118,-0.2028,0.1215,0.2763,-0.363,-0.4366,0.2545,0.0187,-0.088,-0.1261,0.1435,0.1647,-0.0062,-0.8468,-0.2766,-0.0723,-0.0401,0.0044,0.0192,-0.4171;-0.0946,-0.1686,-0.1382,0.334,-0.0458,-0.1513,0.1047,0.2763,0.3135,-0.0142,-0.2115,0.2479,0.0617,-0.1012,0.6765,-0.2376,0.2242,-0.1048,0.305,0.4018,-0.032,-0.0858,-0.2679,-0.1195,-0.0407,-0.405,0.015,0.1367,0.289,-0.2633;0.0797,-0.2903,-0.1571,0.1481,-0.314,0.1483,-0.0964,0.3911,-0.004,0.1017,-0.1701,-0.1593,0.1884,0.2973,-0.2498,0.3578,-0.1655,0.1099,-0.0996,0.5365,0.6679,0.1607,0.0302,-0.0084,-0.186,0.172,0.5065,-0.0182,-0.5131,0.0914;-0.391,-0.4052,-0.2928,-0.0334,0.1677,-0.2175,-0.0283,0.6093,-0.1291,0.0154,0.2668,0.0713,-0.0883,0.2002,0.214,-0.2896,-0.2252,-0.0121,-0.4319,-0.1021,0.176,0.8896,0.2969,-0.2323,0.2672,-0.0187,-0.3941,0.071,-0.5007,-0.07;0.1164,-0.1241,0.0017,-0.1166,-0.2871,0.3832,-0.0232,-0.2324,0.3942,0.1802,0.1154,-0.2814,-0.4764,-0.3277,-0.1524,-0.476,-0.2608,-0.3429,0.4188,0.1359,0.5001,0.2248,0.7585,0.142,0.2312,0.1882,0.2215,-0.5378,0.1615,0.3265;0.2808,-0.2046,0.5017,-0.0998,0.3713,-0.2847,0.5037,-0.0311,0.1392,0.6209,0.366,-0.1891,0.0313,-0.2699,0.0818,-0.3026,0.308,0.0578,-0.026,-0.084,0.0049,-0.1337,-0.225,0.2672,-0.3145,0.1311,0.0636,-0.1361,-0.6162,-0.5223;0.2181,-0.0157,-0.0314,-0.2983,-0.6348,-0.0804,-0.0576,0.1963,0.1817,0.1181,-0.0189,0.3376,-0.3502,-0.428,-0.2196,-0.1762,-0.1422,0.2216,0.0615,0.2011,-0.0871,-0.2959,-0.2506,-0.0251,0.1893,0.0504,-0.1499,0.4605,-0.1994,0.3048;-0.0498,0.0941,0.2365,-0.0331,0.1487,0.1668,-0.725,0.1934,0.1608,0.4743,-0.4571,0.4222,-0.4218,-0.2385,-0.0837,0.0406,0.2162,-0.1377,-0.5627,0.1286,-0.2314,-0.1006,0.2975,-0.0167,0.0518,0.2825,0.0297,-0.189,0.0574,-0.3345;-0.1393,0.2221,-0.1201,-0.3161,0.0512,0.2754,-0.3593,-0.443,0.1501,0.302,-0.4705,0.2727,0.4229,0.0241,0.5458,-0.2455,0.046,0.0535,-0.1943,-0.0388,0.253,0.154,-0.268,-0.0313,-0.2632,0.1871,-0.2473,0.203,-0.2886,0.6311;0.2207,-0.1127,-0.0722,-0.0359,0.1016,0.208,0.2199,-0.6066,-0.2139,-0.0627,0.046,0.0928,-0.1125,0.6482,0.1853,-0.6908,0.1702,-0.1758,-0.1474,0.0219,-0.5167,0.0811,-0.1861,0.0354,0.0525,0.5255,0.4733,0.0288,-0.0506,-0.0724;0.1523,0.3589,0.4031,-0.6708,0.0845,-0.1188,0.1671,-0.0959,0.1734,-0.1772,-0.0589,0.1117,-0.0619,0.564,0.4179,0.0746,0.1466,0.3246,0.0755,0.5198,0.2303,-0.3316,0.5117,0.2855,0.2007,-0.1473,-0.4626,-0.0603,-0.499,-0.0197;0.3144,0.0916,0.2413,0.3082,-0.0158,-0.1084,-0.3337,-0.0977,-0.2342,0.199,0.1187,-0.7064,-0.2967,-0.0389,0.4072,0.1088,-0.0931,-0.2537,0.1777,-0.0119,0.014,-0.0801,0.1641,-0.4028,0.1856,-0.416,0.1253,0.4275,-0.0868,0.1357;0.6246,-0.0212,0.1579,0.02,0.0135,-0.1914,0.0531,0.1648,-0.0256,-0.5205,0.2737,0.3727,0.5056,-0.5061,0.1762,-0.1609,0.0912,-0.3194,0.1008,0.172,0.1117,0.1528,-0.0728,-0.3045,0.343,0.3376,-0.0326,-0.3946,-0.1317,-0.2319;-0.3347,0.208,-0.0645,0.4183,0.0642,0.1753,-0.1108,-0.4374,-0.3935,-0.286,0.5691,0.1018,-0.4549,0.0636,-0.1066,0.0198,0.0777,-0.0295,-0.1244,0.2578,0.576,-0.2258,-0.4057,0.1576,-0.0113,0.1485,-0.0555,-0.3551,-0.224,-0.1254;-0.1985,0.4533,-0.104,0.0326,0.0913,-0.569,-0.2729,0.4099,-0.0827,0.1901,-0.0919,-0.0882,-0.2557,0.2568,0.1249,-0.2379,0.2429,0.2646,0.2247,-0.0263,0.0065,0.2445,-0.2119,0.0023,0.3212,0.2758,0.277,-0.5189,0.1805,0.2359;-0.3194,-0.1816,-0.0621,-0.231,-0.1636,0.0627,-0.4456,0.1778,0.3625,-0.1798,0.5556,-0.4202,0.3934,-0.0039,0.4677,0.1122,-0.2192,0.31,0.0126,0.0667,-0.1537,-0.7071,-0.219,0.142,0.2199,0.1742,0.2031,-0.3337,0.0407,-0.3338;0.0529,-0.3061,0.4045,0.1704,-0.0363,-0.1734,0.1608,0.2399,0.7539,-0.2758,-0.292,0.0455,-0.2602,0.293,0.2111,0.1236,-0.189,-0.2211,-0.1775,-0.1485,-0.0812,0.1496,-0.4782,0.206,0.1998,0.0457,-0.1844,-0.1962,-0.0271,0.2167;-0.121,0.1005,0.2047,-0.4727,-0.3383,-0.2948,0.0007,-0.0731,-0.4137,-0.3126,-0.2672,-0.3758,-0.0445,-0.2055,-0.0388,0.1931,-0.2694,-0.3634,0.1165,0.5595,-0.1386,0.4816,-0.5654,0.0681,-0.3043,0.0262,-0.4209,0.0208,0.3257,-0.1533;-0.4493,0.2447,0.1674,-0.1343,-0.2745,0.0395,-0.0064,-0.1051,-0.3108,-0.6935,-0.5264,0.0073,-0.0912,-0.4356,0.1255,-0.2502,-0.1316,0.2137,-0.3316,-0.4853,0.1737,-0.1018,0.2616,0.1676,0.0754,0.0127,0.5482,0.4163,-0.3082,-0.279;0.0556,0.3762,0.1717,0.3889,-0.5057,-0.1594,-0.0567,-0.278,-0.1244,0.4403,-0.0725,0.3321,0.5397,0.564,-0.3762,-0.1796,-0.2121,-0.0666,0.2303,-0.1002,0.0118,0.1817,-0.1839,0.5152,0.3387,-0.3369,-0.1593,0.1454,-0.1364,-0.395;-0.45,0.2384,-0.3702,0.1521,-0.0527,-0.3783,-0.3215,0.0891,0.2221,-0.1731,0.2656,-0.0533,0.2019,-0.1445,-0.3418,0.3055,0.5902,-0.681,0.1668,0.1866,-0.2286,-0.0813,0.4315,0.3948,-0.0617,0.2846,-0.1679,0.2737,-0.3657,-0.1485;-0.5093,0.0551,0.5574,0.1912,-0.5549,0.1726,0.222,0.3923,-0.2627,0.3153,0.0468,0.3175,0.1559,0.0849,0.1815,-0.008,-0.3377,-0.3527,0.1522,-0.3804,-0.0768,-0.2415,0.1064,-0.299,-0.5469,0.2121,-0.0363,-0.2715,-0.0147,0.1938;0.1115,0.6437,0.1166,0.3677,0.299,-0.0605,-0.0122,0.365,0.061,-0.1767,-0.2188,-0.089,0.1069,-0.1514,-0.3639,-0.5315,-0.6229,-0.1554,-0.3021,0.4387,-0.3377,-0.2878,-0.1208,0.2296,-0.2528,0.1305,-0.0085,-0.1097,-0.0759,0.2726;-0.2716,-0.3487,0.0198,0.0602,-0.0167,0.098,0.319,-0.0365,-0.3544,-0.1563,-0.6094,-0.4293,0.1029,0.0561,-0.2172,-0.2336,0.4703,0.1572,-0.0334,0.2842,0.1147,-0.2226,-0.1058,-0.0387,0.839,0.2203,-0.3735,-0.3205,0.3091,0.1012;-0.2848,-0.3868,0.2895,-0.1028,0.5798,0.619,-0.3523,0.2165,-0.2116,-0.2331,-0.02,0.1102,-0.1272,0.1002,-0.2801,-0.108,0.259,-0.0386,0.3754,-0.0238,-0.1776,0.1103,-0.3209,0.2815,0.0747,-0.2609,0.2653,-0.0996,-0.5574,0.1796;-0.4782,0.4535,0.0214,-0.2726,0.1309,0.3229,0.3891,-0.0263,0.2669,0.1357,0.04,0.0586,0.1618,-0.1563,0.1675,0.3833,-0.4748,-0.0471,0.1214,0.249,0.0436,0.1977,-0.1038,-0.375,0.4276,0.6124,0.1973,0.2323,-0.0788,-0.3383;0.1473,0.6225,0.127,-0.0553,-0.4618,0.6691,0.1878,0.6053,0.1994,0.0676,0.1908,-0.0887,0.1075,-0.0388,-0.0477,-0.1971,0.5972,0.0263,-0.4166,-0.021,0.1345,0.43,-0.0709,0.3147,0.2689,-0.1686,0.2133,-0.0269,0.3164,0.0222;0.359,-0.0721,-0.1565,-0.0243,0.3498,0.5227,-0.3677,0.3839,-0.011,-0.1039,-0.1776,-0.1382,-0.0928,-0.1825,0.0703,-0.0572,0.0626,0.1562,0.4774,-0.3839,0.0161,0.0506,-0.0988,0.1442,-0.1716,0.6623,-0.425,0.5839,0.0905,-0.4033;-0.0684,-0.2598,0.6168,0.2563,0.2366,0.0309,-0.2393,0.0987,0.2818,-0.1492,0.4573,0.0322,0.3832,0.289,-0.1717,-0.0916,0.039,0.4638,0.0137,0.0927,0.3184,0.2551,0.0045,0.0185,-0.187,0.1746,0.2572,0.5741,0.5359,0.2261;]];
if D==100
    M2 = M;
elseif D == 30
    M2 = M1;
end
 %x = x-o;
x = x*M2;
f=sum(x.^2-10.*cos(2.*pi.*x)+10,2);
f = f + fbias;
end
%**********************************************************add by Guohua Wu

% Generalized Penalized Functions 1
function f=penalized_1(x)
y=1+(x+1)./4;
[ps,D]=size(x);
u=(x>10).*100.*((x-10).^4) + (x<=10).*0;
u=(x<-10).*100.*((-x-10).^4) + (x>=-10).*0;
sum1=0;
for i=1:D-1
    sum1=sum1+(y(:,i)-1)^2*(1+10*sin(pi*y(:,i+1))^2);
end

f=pi/30*(10*(sin(pi*y(:,1)))^2 + sum1 + (y(:,D)-1)^2 ) + sum(u,2);
end%--------------------------------

% Generalized Penalized Functions 2 
function f=penalized_2(x)
[ps,D]=size(x);
u=(x>5).*100.*((x-5).^4) + (x<=5).*0;
u=(x<-5).*100.*((-x-5).^4) + (x>=-5).*0;
sum1=0;
for i=1:D-1
    sum1=sum1+(x(:,i)-1)^2*(1+sin(3*pi*x(:,i+1))^2);
end
f=0.1*(sin(3*pi*x(:,1))^2 + sum1 + (x(:,D)-1)^2*(1+sin(2*pi*x(:,D))^2)) + sum(u,2);
end%--------------------------------

% 	23.Kowalik's Function  [-5 5]
function f=kowalik(x)
a=[0.1957 0.1947 0.1735 0.1600 0.0844 0.0627 0.0456 0.0342 0.0323 0.0235 0.0246];
bi_inv=[0.25 0.5 1 2 4 6 8 10 12 14 16];
[ps,D]=size(x);
f=sum(( a - x(:,1).*(1+x(:,2).*bi_inv)./( 1 + x(:,3).*bi_inv + x(:,4).*bi_inv.^2)).^2,2);
%--------------------------------
end
% 	24.Six_hump Camel-back Function  [-5 5]
function f=sixhump_camelback(x)
[ps,D]=size(x);
f=4*x(:,1).^2 - 2.1*x(:,1).^4 + x(:,1).^6./3 + x(:,1).*x(:,2) - 4*x(:,2).^2 + 4*x(:,2).^4;
%--------------------------------
end
% 	25.Branin Function  
function f=branin(x)
[ps,D]=size(x);
f=(x(:,2)-5.1.*x(:,1).^2./(4*pi^2) + 5.*x(:,1)./pi - 6)^2 + 10*(1-1/(8*pi)).*cos(x(:,1)) +10;
%--------------------------------
end
% 	26. 27. Hartman's Family Function  
function f=hartmans_family_1(x)
[ps,D]=size(x);
a=[3 10 30;
    0.1 10 35;
    3 10 30;
    0.1 10 35];
c=[1 1.2 3 3.2];
p=[0.3689 0.1170 0.2673
    0.4699 0.4387 0.7470
    0.1091 0.8732 0.5547
    0.038150 0.5743 0.8828];
for i=1:ps
    f(i)=-sum(c'.*exp(-sum(a.*(repmat(x(i,:),4,1)-p).^2,2)),1);
end
end
%--------------------------------

function f=hartmans_family_2(x)
[ps,D]=size(x);
a=[10 3 17 3.5 1.7 8
    0.05 10 17 0.1 8 14
    3 3.5 1.7 10 17 8
    17 8 0.05 10 0.1 14];
c=[1 1.2 3 3.2];
p=[0.1312 0.1696 0.5569 0.0124 0.8283 0.5886
    0.2329 0.4135 0.8307 0.3736 0.1004 0.9991
    0.2348 0.1415 0.3522 0.2883 0.3047 0.6650
    0.4047 0.8828 0.8732 0.5743 0.1091 0.0381];
for i=1:ps
    f(i)=-sum(c'.*exp(-sum(a.*(repmat(x(i,:),4,1)-p).^2,2)),1);
end
end
%--------------------------------

% 28. Shekel's Family
function f=shekels_family(x)
[ps,D]=size(x);
a=[4 4 4 4
    1 1 1 1
    8 8 8 8
    6 6 6 6
    3 7 3 7
    2 9 2 9
    5 5 3 3
    8 1 8 1
    6 2 6 2
    7 3.6 7 3.6];
c=[0.1 0.2 0.2 0.4 0.4 0.6 0.3 0.7 0.5 0.5];
m=10;
f=0;
for i=1:m
f=f+(((x-a(i,:))*(x-a(i,:))' + c(i)).^-1);
end
f=-f;
end

function M=rot_matrix(D,c)
A=normrnd(0,1,D,D);
P=cGram_Schmidt(A);
A=normrnd(0,1,D,D);
Q=cGram_Schmidt(A);
u=rand(1,D);
D=c.^((u-min(u))./(max(u)-min(u)));
D=diag(D);
M=P*D*Q;
end